Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 482892 - media-libs/mesa - too many drivers enabled for certain USE flags
Summary: media-libs/mesa - too many drivers enabled for certain USE flags
Status: RESOLVED INVALID
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Library (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Matt Turner
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks:
 
Reported: 2013-08-29 09:02 UTC by Hristo Venev
Modified: 2013-09-04 22:10 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Hristo Venev 2013-08-29 09:02:51 UTC
A lot more (up to 7) disabled by USE flags drivers get enabled by the ebuild.

Reproducible: Always

Steps to Reproduce:
USE=llvm classic gallium video_cards_{intel,ilo,radeon,radeonsi}.
Actual Results:  
classic swrast, gallium llvmpipe, classic i915, classic i965, classic r100, classic r200, gallium i915, gallium ilo, gallium r300, gallium r600 and gallium radeonsi

Expected Results:  
classic swrast, gallium llvmpipe, gallium ilo and gallium radeonsi

No classic i915, classic i965, classic r100, classic r200, gallium i915, gallium r300 and gallium r600

Patch on x11:media-libs/mesa-9999:
--- a/media-libs/mesa/mesa-9999.ebuild
+++ b/media-libs/mesa/mesa-9999.ebuild
@@ -206,7 +206,8 @@
                driver_enable video_cards_i915 i915
                driver_enable video_cards_i965 i965
                if ! use video_cards_i915 && \
-                       ! use video_cards_i965; then
+                  ! use video_cards_i915 && \
+                  ! use video_cards_ilo; then
                        driver_enable video_cards_intel i915 i965
                fi
 
@@ -217,7 +218,10 @@
                driver_enable video_cards_r100 radeon
                driver_enable video_cards_r200 r200
                if ! use video_cards_r100 && \
-                               ! use video_cards_r200; then
+                  ! use video_cards_r200 && \
+                  ! use video_cards_r300 && \
+                  ! use video_cards_r600 && \
+                  ! use video_cards_radeonsi; then
                        driver_enable video_cards_radeon radeon r200
                fi
        fi
@@ -243,16 +247,20 @@
                gallium_enable video_cards_i915 i915
                gallium_enable video_cards_ilo ilo
                if ! use video_cards_i915 && \
-                       ! use video_cards_i965; then
-                       gallium_enable video_cards_intel i915
+                  ! use video_cards_i915 && \
+                  ! use video_cards_ilo; then
+                       gallium_enable video_cards_intel i915 ilo
                fi
 
                gallium_enable video_cards_r300 r300
                gallium_enable video_cards_r600 r600
                gallium_enable video_cards_radeonsi radeonsi
-               if ! use video_cards_r300 && \
-                               ! use video_cards_r600; then
-                       gallium_enable video_cards_radeon r300 r600
+               if ! use video_cards_r100 && \
+                  ! use video_cards_r200 && \
+                  ! use video_cards_r300 && \
+                  ! use video_cards_r600 && \
+                  ! use video_cards_radeonsi; then
+                       gallium_enable video_cards_radeon r300 r600 radeonsi
                fi
 
                gallium_enable video_cards_freedreno freedreno
Comment 1 Matt Turner gentoo-dev 2013-09-04 22:10:29 UTC
I think you're expecting USE="gallium video_cards_radeon video_cards_radeonsi" to only enable radeonsi and not r300 and r600, and /not/ build r100 or r200 even though you have classic enabled?

Similarly for USE="gallium video_cards_intel video_cards_ilo" to turn on only ilo?

VIDEO_CARDS="intel" will not turn on ilo. ilo is not an Intel-supported project. Similarly VIDEO_CARDS="intel ilo" will not turn off the actual Intel-supported drivers.

I don't really think this is tractable. Just turn off video_cards_radeon and video_cards_intel and enable only the drivers you actually want.